﻿// mmscript ver 13-12-2017  Script for både version 2016 og 2017
var blendObjArray = [];
var mouseIsDown = false;
var webDirStr = "";
var canAutoplay = false;

var activeDropTargets = [];
var dragDropTimer = undefined;

function soundOrVideoInTimeline(timelineID)
{
    if (timelineID == ''){return};

    var str = readIni('str',timelineID,'Eventstr','');
    var eventArray;
    eventArray = str.split(" ");
    var soundEventEx = false;


    for (index = 0; index < eventArray.length; index++)
    {
        if (readIni('str',timelineID +'_'+ eventArray[index],'EType','') == "etSound")
        {soundEventEx = true}
        return soundEventEx;
    }

}
function executeTimelineEvent(timelineID,eventID)
{
    var delay = 1000 * parseInt(readIni('str',timelineID +'_'+ eventID,'Left',1))/30;

    var eventType = readIni('str',timelineID +'_'+ eventID,'EType','');
    if (eventType == "etSound")
    {
        var myAudio = document.createElement('audio');

        myAudio.setAttribute("src",webDirStr + "data/" + timelineID +'_'+ eventID + ".mp3");
        myAudio.setAttribute('display','none');
        document.body.appendChild(myAudio);
        myAudio.play();
        myAudio.pause();
        setTimeout(function ()
        {
            stopAllAudio();
            myAudio.play();
        }, delay);
        return;
    }

    setTimeout(function ()
    {
        if (eventType == "etShow") { doShowObjects(timelineID +'_'+ eventID,"TimelineInfo")};
        if (eventType == "etHide") { doHideObjects(timelineID +'_'+ eventID,"TimelineInfo")};
        if (eventType == "etPageChange") { doChangePage(timelineID +'_'+ eventID,"TimelineInfo")}
        if (eventType == "etTimeline") { doExecuteTimeline(readIni('str',timelineID +'_'+ eventID,'TimelineInfo',''))};
        if (eventType == "etPageChange") {doChangePage(timelineID +'_'+ eventID,"TimelineInfo")};
        doTerminate('Side' + sidetal,'AfslutOnScore');
    }, delay);
}

function doExecuteTimeline(timelineID)
{
    if (timelineID == ''){return};

    var str = readIni('str',timelineID,'Eventstr','');
    var eventArray;
    eventArray = str.split(" ");

    for (index = 0; index < eventArray.length; index++)
    {
        executeTimelineEvent(timelineID,eventArray[index]);

    }
}

function executeOnRightText(id)
{
    doSpeak(readIni('str',id,'RightText',''))
    doShowObjects(id,'SuccesVis');
    doHideObjects(id,'SuccesSkjul');

    doPlaySound(id,'RightText');
    doExecuteTimeline(readIni('str',id,'StartTimelineSucces',''));

    setTimeout(function ()
    {
        doChangePage(id,'GoToRigthTextPage');
    }, 1200);
}
function centerOnDragdrop(dragObj,targetObj)
{
    var position = targetObj.position();
    var newTop = targetObj.position().top + (targetObj.height() - dragObj.height()) / 2;
    var newLeft = targetObj.position().left + (targetObj.width() - dragObj.width()) / 2;

    dragObj.css("top", newTop.toString() + "px");
    dragObj.css("left", newLeft.toString() + "px");
    dragObj.css("border-radius","0px");
    if (readIni('str', 'Project','LockOnDrop' , '1') == '1')
    {
        dragObj.draggable('disable');
    }

}

function sldSettingsClick()
{

}

function sldNextClick()
{
    loadSLineD("next");
}
function sldPauseClick()
{
    loadSLineD("pause");
}
function sldPlayClick()
{
    loadSLineD("play");
}
function sldBackClick()
{
    loadSLineD("back");
}


function jumpBackOnDragdrop(dragObj,targetObj)
{

    var mixId = blendObjArray[objArray.indexOf(dragObj.attr("id"))];  //case obj are mixed

    if (readIni('str', mixId,'DDTargets','') !== "")
    {
        if (readIni('str', mixId,'JumpBack','1') == "1")
        {
            var newTop = parseInt(readIni('str', mixId,'top','100')) * projectScale + projectTop;
            var newLeft = parseInt(readIni('str', mixId,'left','100')) * projectScale + projectLeft;
            dragObj.css("top", newTop.toString() + "px");
            dragObj.css("left", newLeft.toString() + "px");
        }
    }
    else
    {
        if (readIni('str', mixId,'JumpBack','1') == "1")
        {
            var newTop = parseInt(readIni('str', mixId,'top','100')) * projectScale + projectTop;
            var newLeft = parseInt(readIni('str', mixId,'left','100')) * projectScale + projectLeft;
            dragObj.css("top", newTop.toString() + "px");
            dragObj.css("left", newLeft.toString() + "px");
        }
    }

}



function SetupDragDrop()
{
    var dragArray = [];
    var dropArray = [];


    for (var i = 0; i < objArray.length; i++)
    {
        dropArray.push(objArray[i]); //all object are potential targets

        if (readIni('str', objArray[i], 'Dragable' , '0' ) == "1")
        {
            if (dragArray.indexOf(objArray[i]) == -1 )
            {
                dragArray.push(objArray[i]);
            }
        }
    }

    var dragObjStr = '';
    for (var i = 0; i < dragArray.length; i++)
    {
        if (i == 0) {dragObjStr = '#' + dragArray[i]}
        else
        {dragObjStr = dragObjStr +', #' + dragArray[i]}
    }

    var dropObjStr = '';
    for (var i = 0; i < dropArray.length; i++)
    {
        if (i == 0) {dropObjStr = '#' + dropArray[i]}
        else
        {dropObjStr = dropObjStr +', #' + dropArray[i]}
    }


    $(function()
    {
        $(dragObjStr).draggable(
        {
            start: function( event, ui )
            {
                var z = incZIndex();
                $(this).css("zIndex", z )
            }
        });



        $(dropObjStr ).droppable(
        {
            //accept: (dragObjStr),
            drop: function(event, ui)
            {
                //START CROSSWORD DRAGDROP
                if (readIni('str', $(ui.draggable).attr("id"),'CWO','0') == "1")
                {

                if (crosswordStyle(false) == 0)
                    {
                       if (readIni('str',$(ui.draggable).attr("id"),'Caption',"") == readIni('str', $(this).attr("id"),'CWV',""))
                       {
                           $(this).droppable('disable');
                           scorePoint("",false);
                           centerOnDragdrop($(ui.draggable),$(this));
                       }
                       else
                       {
                           jumpBackOnDragdrop($(ui.draggable),$(this));
                       }
                    }
                    return;
                }
                //END CROSSWORD DRAGDROP

                //START NORMAL DRAGDROP
                activeDropTargets.push($(this).attr("id")); //there can be several targets. We want to drop on the topmost
                clearTimeout(dragDropTimer);
                dragDropTimer = setTimeout(function ()
                {

                    var s = activeDropTargets[0];
                    var dropObj =  $("#" + activeDropTargets[0]);

                    activeDropTargets = [];

                    var tempTargetStr = readIni('str', $(ui.draggable).attr("id"), 'DDTargets' , '' );

                    var tempTargetArray = tempTargetStr.split(" ");


                    var tempTargetArrayIndex = tempTargetArray.indexOf(dropObj.attr("id"));

                    if (tempTargetArrayIndex !== -1)
                    {
                        //alert("match");
                        centerOnDragdrop($(ui.draggable),dropObj);
                        scorePoint($(ui.draggable).attr("id") + '_' + dropObj.attr("id"));

                        doExecuteTimeline(readIni('str',$(ui.draggable).attr("id"),"DD_" + dropObj.attr("id") + "_StartTimeline",''));
                        doShowObjects($(ui.draggable).attr("id"),'DD_' + dropObj.attr("id") + '_Vis');
                        doHideObjects($(ui.draggable).attr("id"),'DD_' + dropObj.attr("id") + '_Skjul');

                        doPlaySound($(ui.draggable).attr("id"),$(ui.draggable).attr("id") + '_DD_' + dropObj.attr("id") + '_Sound');
                        doStartVideo($(ui.draggable).attr("id"),'DD_' + dropObj.attr("id") + '_StartVideo');
                        doTerminate($(ui.draggable).attr("id"),'DD_' + dropObj.attr("id") + '_Afslut');
                        doChangePage($(ui.draggable).attr("id"),'DD_' + dropObj.attr("id") + '_Sideskift');
                        user_dragdrop($(ui.draggable).attr("id"),dropObj.attr("id"));

                    }
                    else
                    {
                        jumpBackOnDragdrop($(ui.draggable),dropObj);
                    }


                }, 100);

                //END NORMAL DRAGDROP
            }
        });

    });
};


function shuffle(array)
{
    var currentIndex = array.length, temporaryValue, randomIndex ;
    // While there remain elements to shuffle...
    while (0 !== currentIndex)
    {
        // Pick a remaining element...
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;

        // And swap it with the current element.
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
    }
    return array;
}

//var str = readIni('str','Project','Pages','');
//            pageArray = str.split(" ");

var incZIndex = (function noCall_incZIndex() {
    var zIndexMax = 1;
    return function (myParameter)
    {
        zIndexMax += 1;
        return zIndexMax;
    }
})();

function setAuto(value)
{
    if (value == true)
    {
        setCookie("sldauto", "1",365)
    }
    else
    {
        setCookie("sldauto", "0",365)
    }
}

var loadSLineD = (function noCall_loadSLineD() {
    var lineIndex = -1;
    var lineArray = [];
    var sldLabel;
    var auto = true;
    var sldTimer;
    var speed = 3000;
    var isPlayingAudio = false;

    return function (event,id)
    {

        if (event == "load")
        {
            var sldStr = readIni('str','Side' + sidetal,'SLDtext','');
            if (sldStr == '') {return};

            var sp;
            sp = getCookie("sldspeed");
            if (sp == "") {sp = '3'}
            document.getElementById("sldSpeed").value = parseInt(sp);

            speed = parseInt(sp) * 1000;

            setCookie("sldspeed", document.getElementById("sldSpeed").value,365);

            document.getElementById("sldPause").style.visibility = "visible";
            document.getElementById("sldPlay").style.visibility = "hidden";
            sldLabel = document.getElementById("sldlabel");

            lineArray = sldStr.split("*");

            var isAuto;
            isAuto = getCookie("sldauto");

            if (isAuto == "0")
            {
                auto = false;
                document.getElementById("sldPause").style.visibility = "hidden";
                document.getElementById("sldPlay").style.visibility = "visible";
            }
            else
            {
                auto = true;
                document.getElementById("sldPause").style.visibility = "visible";
                document.getElementById("sldPlay").style.visibility = "hidden";
            };
            loadSLineD("next");

            return;
        }
        if (sldLabel == undefined) {return};

        if (event == "playline")
        {
            sldLabel.innerHTML = lineArray[lineIndex];
            stopAllAudio();

            if (readIni('str','Side' + sidetal,'SLDSound' + lineIndex.toString(),'') != '')
            {
                var myAudio = document.createElement('audio');
                myAudio.setAttribute("src",webDirStr + "data/" + readIni('str','Side' + sidetal,'SLDSound' + lineIndex.toString(),''))
                myAudio.setAttribute('display','none');
                document.body.appendChild(myAudio);
                myAudio.play();

                setTimeout(function ()
                {
                    var newSpeed;
                    if (speed < myAudio.duration * 1000) {newSpeed = myAudio.duration * 1000} else {newSpeed = speed};
                    if (auto == true) {sldTimer = setTimeout(function (){loadSLineD("next");}, newSpeed); };
                }, 1000);

            }
            else
            {
                if (auto == true) {sldTimer = setTimeout(function (){loadSLineD("next");}, speed); };
            }

        }

        if (event == "setspeed")
        {
            speed = parseInt(document.getElementById("sldSpeed").value) * 1000;
            setCookie("sldspeed", document.getElementById("sldSpeed").value,365);
            if (auto == true)
            {
                clearTimeout(sldTimer);
                loadSLineD("playline");
            }

            return;
        }
        if (event == "pause")
        {
            document.getElementById("sldPause").style.visibility = "hidden";
            document.getElementById("sldPlay").style.visibility = "visible";
            clearTimeout(sldTimer);
            auto = false;
            setAuto(auto);
            return;
        }
        if (event == "play")
        {
            document.getElementById("sldPause").style.visibility = "visible";
            document.getElementById("sldPlay").style.visibility = "hidden";
            auto = true;
            loadSLineD("next");
            setAuto(auto);
            return;
        }
        if (event == "back")
        {
            if (auto == true) {clearTimeout(sldTimer);}
            lineIndex -= 1;
            if (lineIndex == -1) {lineIndex = 0};

            loadSLineD("playline");
            return;
        }

        if (event == "next")
        {
            if (auto == true) {clearTimeout(sldTimer);}
            lineIndex += 1;
            if (lineIndex > lineArray.length - 1 )
            {
                doChangePage('right','')
            }
            else
            {
                loadSLineD("playline");
            };
            return;
        }
    }
})();

var incAudioC = (function noCall_incAudioCount() {
    var audioCMax = 1;
    return function (myParameter)
    {
        audioCMax += 1;
        return audioCMax;
    }
})();

var capsLock = (function noCall_capsLock() {
    var locked = false;
    return function (set,id)
    {
        if (set == true)
        {
            if (locked == false)
            {
                locked = true;
                document.getElementById(id).style.boxShadow = "0px 0px 2px 2px red";
            }
            else
            {
                locked = false;
                document.getElementById(id).style.boxShadow = "";
            };
            for (var i = 0; i < objArray.length; i++)
            {
                if (readIni('str', objArray[i], 'AKey' , '0' ) == "1")
                {
                    var value = document.getElementById("lb" + objArray[i]).innerHTML;

                    if (locked == true)
                    {
                        document.getElementById("lb" + objArray[i]).innerHTML = value.toUpperCase();
                    }
                    else
                    {
                        document.getElementById("lb" + objArray[i]).innerHTML = value.toLowerCase();
                    };

                }
            }
        }
        return locked;
    }
})();

var doBlend = (function noCall_doBlend() {
    var blend = true;
    return function (set,value)
    {
        if (set == true){blend = value;}
        return blend;
    }
})();


var scorePoint = (function noCall_scorePoint() {
    var pointCounter = 0;
    var pointEventArray = [];
    return function (eventId,reset)
        {

            if (reset == true)
            {
                var s = readIni('str','Side' + sidetal,'PEvents','');
                pointEventArray = s.split(" ");
                return;
            }
            if (eventId != "")
            {
                var index = pointEventArray.indexOf(eventId);
                if (index == -1){return};

                if (readIni('str','Side' + sidetal,'ScoreOnlyOnce','1') == '1')
                {
                    pointEventArray.splice(index, 1); //remove from pointEventArray
                }
            }

            pointCounter += 1;
            for (var index = 0; index <  objArray.length; index++)
            {

                if (readIni('str',objArray[index],'PDisplay','0') ==  "1")
                {

                   var objLabel = document.getElementById(objArray[index] + 'label');
                   if (objLabel != undefined)
                   {
                        var cap = readIni('str', objArray[index], 'Caption', '#');
                        cap = cap.replace("#", pointCounter.toString());
                        cap = cap.replace("~", "");
                        objLabel.innerHTML = cap;
                   }
                }
            }


            var maxPoint = parseInt(readIni('str',"Side" + sidetal,'MaxPoint', "0"));
            if (pointCounter == maxPoint)
            {
                doShowObjects('Side' + sidetal,'OnScoreVis');
                doHideObjects('Side' + sidetal,'OnScoreSkjul');

                doPlaySound('Side' + sidetal,'POSound');
                doTerminate('Side' + sidetal,'AfslutOnScore');
                doStartVideo('Video' + sidetal,'StartVideoOnScore');

                doExecuteTimeline(readIni('str','Side' + sidetal,'StartTimelineOnScore',''));
                setTimeout(function ()
                {
                    doChangePage('Side' + sidetal,'OnScorePage');
                }, 1200);
            }

        }
})();




var crosswordStyle = (function noCall_crosswordStyle() {
    var invertCWSecection = false;
    return function (set)
    {
        if (set == true)
        {
            if (invertCWSecection == true) {invertCWSecection = false} else  {invertCWSecection = true};
            return;
        }
        var style = parseInt(readIni('str',"Side" + sidetal,'CWStyle', "0"));
        return style;

        if (invertCWSecection == true)
        {
            if (style == 1) {style = 0} else {style = 1};
        }
        return style;
    }
})();

var playCrossWord = (function noCall_playCrossWord() {  //play by match
    var crossWordTarget = undefined;
    var crossWordBrick = undefined;
    return function (id)
        {
           if (crosswordStyle(false) == 0) {return};

            if (readIni('str', id,'CWO','%') == "%")
            {
                if (readIni('str', id,'CWV','%') == "%") {return};
            };

            if (readIni('str', id,'CWV','') != "")
            {
                if (crossWordTarget != undefined)
                {
                    if (crossWordTarget != id)
                    {
                        document.getElementById(crossWordTarget).style.boxShadow = "";
                    }
                }
                crossWordTarget = id;
                document.getElementById(id).style.boxShadow = "0px 0px 5px 5px red";

                document.getElementById(id).style.zIndex = incZIndex();

                if (crossWordBrick == undefined){return};
            }
            else
            {
                if (crossWordBrick != undefined)
                {
                    if (crossWordBrick != id)
                    {
                        document.getElementById(crossWordBrick).style.boxShadow = "";
                    }
                }
                crossWordBrick = id;
                document.getElementById(id).style.boxShadow = "0px 0px 5px 5px red";
                document.getElementById(id).style.zIndex = incZIndex();
                if (crossWordTarget == undefined){return};
            };

            if (readIni('str',crossWordTarget,'CWV', "#") == readIni('str',crossWordBrick,'Caption', "%"))
            {
                document.getElementById(crossWordBrick).style.boxShadow = "0px 0px 5px 5px green";
                document.getElementById(crossWordTarget).style.boxShadow = "0px 0px 5px 5px green";

                var targetObj = $("#" + crossWordTarget);
                var brickObj = $("#" + crossWordBrick);
                brickObj.prop( "onclick", null);
                targetObj.prop( "onclick", null);
                targetObj.css('zIndex', incZIndex());
                brickObj.css('zIndex', incZIndex());
                var position = targetObj.position();

                var newTop = position.top + (targetObj.height() - brickObj.height()) / 2;
                var newLeft = position.left + (targetObj.width() - brickObj.width()) / 2;

                brickObj.css("top", newTop.toString() + "px");
                brickObj.css("left", newLeft.toString() + "px");

                scorePoint("",false);
            }
            document.getElementById(crossWordBrick).style.boxShadow = "";
            crossWordBrick = undefined;

            setTimeout(function ()
            {
                document.getElementById(crossWordTarget).style.boxShadow = "";
                crossWordTarget = undefined;
            }, 500);

        }
})();


var playMemory = (function noCall_playMemory() {
    var memoryTimer = undefined;
    var firstMemButton = undefined;


    function memoryAllFound()
    {
        var count = 0;
        var found = 0;
        for (var i = 0; i < objArray.length; i++)
        {
            if (readIni('str',objArray[i],'MemValue',"0") != "0")
            {
                count += 1;
                if (document.getElementById(objArray[i]).style.visibility == "hidden")
                {
                found += 1;
                }
            }
        }
        if (count > found) {return false}  else {return true};
    }
    return function (id)
{
    var obj = document.getElementById(id);
    if (readIni('str',"Side" + sidetal,'AOS', "0") == "1") {} //{if (!SidelydSlut){return}}
    if (firstMemButton == obj) {return};
    if (readIni('str',id,'MemValue',"0") == "0") {return};  //ikke en memorybrik

    if (memoryTimer != undefined) {return};

    if (readIni('str', 'Side' + sidetal, 'MemoryOpenCards', '0') != '1')
    {
        obj.style.backgroundImage = 'url("none")';
        document.getElementById("img" + id).style.display  = "block";
        document.getElementById("lb" + id).style.display  = "block";
    }
    var memDelay = parseInt(readIni('str','Side' + sidetal,'MemoryDelay',"500"));
    obj.style.boxShadow = "0px 0px 5px 5px red";
    obj.style.zIndex = incZIndex();

    if (firstMemButton == undefined) //select 1. button
    {
        firstMemButton = obj;
	    return;
    }
    else //select 2. button
    {

        if ((readIni('str',firstMemButton.id,'MemValue',"0") == readIni('str',id,'MemValue',"0")) &&
        (readIni('str',firstMemButton.id,'MemAorB',"0") != readIni('str',id,'MemAorB',"0")))
        {
            doPlaySound('Side' + sidetal,'MRSound');
            doChangePage('Side' + sidetal, 'GoToMemoryPageMR');
            doExecuteTimeline(readIni('str','Side'+ sidetal,'StartTimelineMemoryR',''));

            memoryTimer = setTimeout(function ()
            {
                memoryTimer = undefined;

                document.getElementById("img" + id).style.display  = "none";
                document.getElementById("lb" + id).style.display  = "none";
               	document.getElementById(id).style.visibility = "hidden";

                document.getElementById("img" + firstMemButton.id).style.display  = "none";
                document.getElementById("lb" + firstMemButton.id).style.display  = "none";
               	firstMemButton.style.visibility = "hidden";
                firstMemButton = undefined;
                if (memoryAllFound() == true)
                {
                    doPlaySound('Side' + sidetal,'MDSound');
                    doChangePage('Side' + sidetal, 'GoToMemoryPage');
                    doShowObjects('Side' + sidetal,'MemoryVis');
                    doHideObjects('Side' + sidetal,'MemorySkjul');
                    doExecuteTimeline(readIni('str','Side'+ sidetal,'StartTimelineMemory',''));
                }
            }, memDelay);



        } else
        {
	        doPlaySound('Side' + sidetal,'MWSound');
            doChangePage('Side' + sidetal, 'GoToMemoryPageMW');
            doExecuteTimeline(readIni('str','Side'+ sidetal,'StartTimelineMemoryW',''));

    	    memoryTimer = setTimeout(function ()
            {
         		memoryTimer = undefined;


              	//document.getElementById(id).style.border = "";
                document.getElementById(id).style.boxShadow = "";
              	//document.getElementById(firstMemButton).style.border = "";
                firstMemButton.style.boxShadow = "";

                if (readIni('str', 'Side' + sidetal, 'MemoryOpenCards', '0') != '1')
                {

                    document.getElementById("img" + firstMemButton.id).style.display  = "none";
                    document.getElementById("lb" + firstMemButton.id).style.display  = "none";
                    firstMemButton.style.backgroundImage = 'url("' + webDirStr + 'data/MemoryBack' + sidetal +'.png")';
                    firstMemButton.style.backgroundSize = "contain";

                    document.getElementById("img" + id).style.display  = "none";
                    document.getElementById("lb" + id).style.display  = "none";
                    obj.style.backgroundImage = 'url("' + webDirStr + 'data/MemoryBack' + sidetal +'.png")';
                    obj.style.backgroundSize = "contain";
                }
                firstMemButton = undefined;

            }, memDelay);
        }
   }
}
})();


function getOperatingSystem()
{
    var userAgent = navigator.userAgent || navigator.vendor || window.opera;

    if( userAgent.match( /iPad/i ) || userAgent.match( /iPhone/i ) || userAgent.match( /iPod/i ) ) {return 'iOS'}
    else if( userAgent.match( /Android/i ) ){ return 'Android'}
    else if( userAgent.match( /Windows/i ) ){return 'Windows'}
    else if( userAgent.match( /Macintosh/i ) ){return 'Mac'}
    else if( userAgent.match( /Linux/i ) ){ return 'Linux'}
    else {return 'unknown'}
}

function setProjectScale()
{
    var pClientWidth = parseInt(readIni('str','Project','ClientWidth','1'));
    if (pClientWidth == 1) {pClientWidth = parseInt(readIni('str','Projekt','MainformWidth','1024')) - 10};

    var pClientHeight = parseInt(readIni('str','Project','ClientHeight','1'));
    if (pClientHeight == 1) {pClientHeight = parseInt(readIni('str','Projekt','MainformHeight','768')) - 20};

    var projectRatio =  pClientWidth / pClientHeight;

    var windowRatio;

    if
    (
        (getOperatingSystem() == "iOS") && (!!window.cordova)
    )
    {
        windowRatio =  screen.width/screen.height;
        if (projectRatio > windowRatio)
        {
            projectWidth =  screen.height;
            projectHeight = projectWidth / projectRatio;
            projectTop = (screen.width - projectHeight) / 2;
            projectScale = screen.height / pClientWidth;
            projectLeft = 0;
        }
        else
        {
            projectHeight =  screen.width;
            projectWidth = projectHeight * projectRatio;
            projectTop = (screen.width - projectHeight) / 2;
            projectLeft = (screen.height - projectWidth) / 2;
            projectScale = screen.width / pClientHeight;
        }
        projectScale = projectScale * 0.95;
    }
    else
    if (
        (getOperatingSystem() !== "iOS") ||
        (getOperatingSystem() == "Android")||
        //windows MacOs or iOS with Safari Chrome Firefox
        (navigator.userAgent.indexOf("Safari") > -1) ||
        (navigator.userAgent.indexOf("Chrome") > -1) ||
        (navigator.userAgent.indexOf("Firefox") > -1))
    {
        windowRatio =  window.innerWidth/window.innerHeight;
        if (projectRatio > windowRatio)
        {
            projectWidth = window.innerWidth;
            projectHeight = projectWidth / projectRatio;
            projectTop = (window.innerHeight - projectHeight) / 2;
            projectScale = window.innerWidth / pClientWidth;
            projectLeft = 0;
        }
        else
        {
            projectHeight = window.innerHeight;
            projectWidth = projectHeight * projectRatio;
            projectTop = 0;
            projectLeft = (window.innerWidth - projectWidth) / 2;
            projectScale = window.innerHeight / pClientHeight;
        }
    }

}

function checkForRightText(textTargetId,inputText)
{
    var rightText = readIni('str',textTargetId,'RightText','');
    rightText = rightText.trim();
    //Upper-Lower Case and spaces does not matter
    inputText = inputText.replace(/\s+/g, '');
    inputText = inputText.toLowerCase();
    rightText = rightText.replace(/\s+/g, '');
    rightText = rightText.toLowerCase();

    if (inputText == rightText)
    {

        executeOnRightText(textTargetId);
        scorePoint(textTargetId + "_RT",false)
    };

}



var markRightTextSender = (function noCall_markRightTextSender() {
    var wrongTextCounter = 0;
    return function (input,reset)
        {
            if (reset == true)
            {
                wrongTextCounter = 0;
                return;
            }
            wrongTextCounter += 1;
            if (wrongTextCounter > 1)
            {
                for (index = 0; index <  objArray.length; index++)
                {
                    var caption = readIni('str',objArray[index],'Caption','');
                    caption = caption.replace("~", "");
                     if (input.toLowerCase() == caption.toLowerCase())
                     {
                        var obj = document.getElementById(objArray[index]);
                        obj.style.boxShadow = "0px 0px 8px 8px red";
                        obj.style.zIndex = incZIndex();
                     }
                }

            }

        }
})();


function doSendText(id)
{
    var textTarget = document.getElementsByName("textTarget")[0];

    if (textTarget == undefined){return};
    if (readIni('str',id,'SendText','0') == "0") {return};

    var targetValue = textTarget.value;

    var space = "";
    if (readIni('str',textTarget.id,'AddSpace','1') == "1") {space = " "};

    var caption = readIni('str',id,'Caption','');
    caption = caption.replace("~", "");

    if (caption == "") {caption = " "} else {caption = caption.trim()};

    if (readIni('str',textTarget.id,'AcceptOR','') == "1")
    {
        var rightText = readIni('str',textTarget.id,'RightText','');
        rightText = rightText.trim();

        var restText = rightText.slice(targetValue.length, rightText.length);
        restText = restText.trim();
        var nextChar = restText.slice(0,caption.length);
        if (nextChar.toLowerCase() != caption.toLowerCase())
        {
            markRightTextSender(nextChar,false);
            return;
        }
    }

    document.getElementById(id).style.boxShadow = "";
    markRightTextSender("",true); //reset
    if (caption.length == 1) //keyboard
    {
        if (nextChar == undefined)
        {
            if (capsLock(false,"") == true) {caption = caption.toUpperCase()} else {caption = caption.toLowerCase()}
        }
        else
        {
            caption = nextChar;
        }
    }

    targetValue = targetValue + space + caption;

    if (caption != " "){targetValue = targetValue.trim()};

    if (readIni('str',id,'ClearText','0') == "1") {targetValue = caption};
    //display

    textTarget.value = targetValue;
    //textTarget.focus();
    //setCaretPosition(textTarget.id,textTarget.value.length);
    //textTarget.focus();

    checkForRightText(textTarget.id,targetValue);
}

function setCaretPosition(elemId, caretPos) {
    var elem = document.getElementById(elemId);

    if(elem != null) {
        if(elem.createTextRange) {
            var range = elem.createTextRange();
            range.move('character', caretPos);
            range.select();
        }
        else {
            if(elem.selectionStart) {
                elem.focus();
                elem.setSelectionRange(caretPos, caretPos);
            }
            else
                elem.focus();
        }
    }
}

function doEraseText()
{
    var textTarget = document.getElementsByName("textTarget")[0];
    if (textTarget == undefined) {return};
    textTarget.value = "";
    textTarget.focus();
}

function exitpageProperties()
{
    if (getWebpageName() !== "exit.htm") {return};
    var imgLink = document.getElementById("imgLink");
    var imgMenu = document.getElementById("imgMenu");
    var imgReplay = document.getElementById("imgReplay");
    var imgGoback = document.getElementById("imgGoback");

    imgReplay.style.visibility = "visible";
    imgGoback.style.visibility = "visible";
    imgMenu.style.visibility = "visible";

    if (readIni('str', 'exitPage', 'link' , '' ) !== "")
    {
        imgLink.style.visibility = "visible";
        document.getElementById('userLink').href = readIni('str', 'exitPage', 'link' , '' );
    }

    if (readIni('str','Project','hpmenuex','0') == '1')
    {
        imgMenu.style.visibility = "visible";
        alert("yes do it")
    }


}

function hotspotOnTop(id)
{
return;
if (id.charAt(0) != "Q") {return};
    var obj = document.getElementById(id);
    if (obj == undefined) {return};
    alert(id.charAt(0));
    obj.style.zIndex = incZIndex();
}


function LightenDarkenColor(hex, lum) {

	// validate hex string
	hex = String(hex).replace(/[^0-9a-f]/gi, '');
	if (hex.length < 6) {
		hex = hex[0]+hex[0]+hex[1]+hex[1]+hex[2]+hex[2];
	}
	lum = lum || 0;

	// convert to decimal and change luminosity
	var rgb = "#", c, i;
	for (i = 0; i < 3; i++) {
		c = parseInt(hex.substr(i*2,2), 16);
		c = Math.round(Math.min(Math.max(0, c + (c * lum)), 255)).toString(16);
		rgb += ("00"+c).substr(c.length);
	}

	return rgb;
}


function objProperties(id,isResizing)
{

    var obj = document.getElementById(id);
    if (obj == undefined) {return};
    var newWidth;
    var newHeight;
    var newLeft;
    var newTop;
    var ratio;
    //start set position

    if (id == "speaker")
    {
        newWidth = projectWidth * 0.06;
        newHeight = newWidth;
        newTop = projectHeight - newHeight - (30 * projectScale) + projectTop;
        newLeft = (projectWidth/2) - (newWidth/2) + projectLeft;
        obj.style.cursor = "pointer";
        //obj.onclick = function(){myOnclick(id)}

    } else if (id == "right")
    {
        newWidth = parseInt(readIni('str','AB','Width', '100')) * projectScale;
        newHeight = parseInt(readIni('str','AB','Height','100')) * projectScale;

        newTop = parseInt(readIni('str','Arrows','Top','20')) * projectScale + projectTop;
        newLeft = parseInt(readIni('str','Arrows','RLeft','20')) * projectScale + projectLeft;


        obj.style.cursor = "pointer";
        obj.onclick = function(){myOnclick(id)}
    } else if (id == "left")
    {

        newWidth = parseInt(readIni('str','AB','Width','100')) * projectScale;
        newHeight = parseInt(readIni('str','AB','Height','100')) * projectScale;

        newTop = parseInt(readIni('str','Arrows','Top','20')) * projectScale + projectTop;
        newLeft = parseInt(readIni('str','Arrows','LLeft','20')) * projectScale + projectLeft;


        obj.style.cursor = "pointer";
        obj.onclick = function(){myOnclick(id)}

    } else if (id == "sldcontainer")
    {
        var selectSpeed = document.getElementById("sldSpeed");
        selectSpeed.style.left = (300 * projectScale).toString() + 'px';
        selectSpeed.style.fontSize = (14 * projectScale).toString() + 'px';

        var speedLabel = document.getElementById("lbSldspeed");
        speedLabel.style.left = (230 * projectScale).toString() + 'px';
        speedLabel.style.fontSize = selectSpeed.style.fontSize;

        document.getElementById("sldSettings").style.left = (30 * projectScale).toString() + 'px';
        document.getElementById("sldNext").style.left = (80 * projectScale).toString() + 'px';
        document.getElementById("sldPause").style.left = (130 * projectScale).toString() + 'px';
        document.getElementById("sldPlay").style.left = (130 * projectScale).toString() + 'px';
        document.getElementById("sldBack").style.left = (180 * projectScale).toString() + 'px';

        var sldWidth;
        if (readIni('str','SLineD','width','0') == 0)
        {sldWidth = (projectWidth * 0.8).toString(); }
        else sldWidth = (parseInt(readIni('str','SLineD','width','0')) * projectScale).toString();


        obj.style.visibility = "visible";
        obj.style.width = sldWidth + 'px';

        obj.style.height = (100 * projectScale).toString() + 'px';
        obj.style.top = (parseInt(readIni('str','SLineD','top','200')) * projectScale + projectTop).toString() + 'px';
        obj.style.left = (parseInt(readIni('str','SLineD','left','200')) * projectScale + projectLeft).toString() + 'px';

        obj.style.fontSize = (parseInt(readIni('str','SLineD','FontSize','40')) * projectScale * 1.3).toString() +"px";
        obj.style.fontFamily = readIni('str','SLineD','FontName','Tahoma');
        return;
    } else
    {
        var iniSection = blendObjArray[objArray.indexOf(id)];  //case obj are mixed

        newHeight = parseInt(readIni('str',id,'height','100')) * projectScale + 1;
        newWidth = parseInt(readIni('str',id,'width','100')) * projectScale + 1;
        newLeft = parseInt(readIni('str',iniSection,'left','100')) * projectScale + projectLeft;
        newTop = parseInt(readIni('str',iniSection,'top','100')) * projectScale + projectTop;

        if (readIni('str',iniSection,'WSCursor','0') == "1") {obj.style.cursor = "pointer"};
        obj.onmouseleave = function(){myMouseLeave(id)};
        obj.onmouseenter = function(){myMouseEnter(id)};
        //obj.onclick = function(){myOnclick(id)}
        obj.onmousedown = function()
        {
            mouseIsDown = true;
            myOnclick(id);
        };




        obj.onmouseup = function(){mouseIsDown = false};
        if (readIni('str', id, 'Dragable' , '0' ) == "1")  {obj.style.zIndex = 1}

        if (readIni('str', 'Side' + sidetal, 'TextTarget' , '' ) == id)
        {
            myFont =  projectScale * parseInt(readIni('str', id, 'stFontSize' , '20' ));
            obj.style.fontSize = myFont.toString() + "px";
            obj.style.textAlign = "center";
            obj.onkeyup = function(){myOnKeyUp(id)};
            obj.style.fontFamily = readIni('str', id, 'stFontName' , 'arial');
            obj.style.overflow = "auto";

            if (readIni('str', id, 'ShowDeleteTextButton' , '1' ) == "1")
            {
                var eraseButton = document.getElementById("eraseText");

                if (eraseButton != undefined)
                {
                    eraseButton.style.position = "absolute";
                    eraseButton.style.height =  (40 * projectScale).toString() + "px";
                    eraseButton.style.width =  (80 * projectScale).toString() + "px";
                    eraseButton.style.left =  (newLeft + newWidth - 80 * projectScale + 8).toString() + "px";
                    eraseButton.style.top =  (newTop + newHeight + 8).toString() + "px";
                    eraseButton.style.visibility = "visible";
                    eraseButton.onclick = function(){doEraseText()}
                }
            }

        }

        if (readIni('str', id, 'KB_Button' , '' ) == "key:swap") //keyboard
        {
            obj.style.boxShadow = "";
            obj.style.borderRadius = "10px";
        }

        if (readIni('str', id, 'AKey' , '0' ) == "1") //keyboard key
        {
            obj.style.borderRadius = "10px";
            var value = document.getElementById("lb" + id).innerHTML;
            document.getElementById("lb" + id).innerHTML = value.toLowerCase();
        }

    }


    obj.style.position = "absolute";
    //obj.style.opacity = "0.2";
    obj.style.height =  newHeight.toString() + "px";
    obj.style.width =  newWidth.toString() + "px";
    obj.style.left =  newLeft.toString() + "px";
    obj.style.top =  newTop.toString() + "px";

    if (readIni('str',id,'isLabel','0') ==  "1")
    {


        obj.style.fontSize = (parseInt(readIni('str', id, 'LabelFontSize' , '20' )) * projectScale * 1.3).toString() +"px";

        if (readIni('str',id,'fsBold','0') ==  "1") {obj.style.fontWeight = "bold";}
        if (readIni('str',id,'fsItalic','0') ==  "1") {obj.style.fontStyle = "italic";}
        if ((readIni('str',id,'fsUnderline','0') ==  "1") && (readIni('str',id,'fsStrikeOut','0') ==  "1"))
        {obj.style.textDecoration = "underline line-through";}
        else
        if (readIni('str',id,'fsUnderline','0') ==  "1") {obj.style.textDecoration = "underline";}
        else
        if (readIni('str',id,'fsStrikeOut','0') ==  "1") {obj.style.textDecoration = "line-through";}

        if (readIni('str',id,'CopyBackgroundStyle','0') ==  "1")
        {
            obj.style.borderStyle = "none";
        }
        if (readIni('str',id,'BoxStyle','0') ==  "1")
        {
            obj.style.borderStyle = "solid";
        }
        if (readIni('str',id,'LabelStyle','0') ==  "1")
        {
            obj.style.borderColor = "none";
        }
        if (readIni('str',id,'BubbelStyle','0') ==  "1")
        {

            obj.style.borderStyle = "black";

            var sizeBlack = (newHeight / 9) + 4;
            var sizeWhite = newHeight / 9;

            var whiteArrowBottom = -sizeWhite * 1.4;
            var blackArrowBottom = -sizeWhite * 1.4 - 4;

            if (newHeight > newWidth)
            {
                sizeBlack = (newWidth / 9) + 4;
                sizeWhite = newWidth / 9;
                whiteArrowBottom = -sizeWhite * 1.3 ;
                blackArrowBottom = -sizeWhite * 1.3 - 4;
            }

            var whiteArrowLeft = newWidth / 4;
            var blackArrowLeft = (newWidth / 4) - 2;

            obj.style.borderWidth = 1;



           if (readIni('str',id,'BubbleLeft','1') ==  "1") //to the left
            {
                obj.pseudoStyle("after","border-left-color",obj.style.backgroundColor);
                obj.pseudoStyle("after","border-top-color",obj.style.backgroundColor);
                obj.pseudoStyle("after","border-right-color","transparent");
                obj.pseudoStyle("after","border-bottom-color","transparent");


                obj.pseudoStyle("before","left",blackArrowLeft.toString() +"px");  //black
                obj.pseudoStyle("before","bottom",blackArrowBottom.toString() +"px");
                obj.pseudoStyle("before","border-width",sizeBlack.toString() +"px");

                obj.pseudoStyle("after","left",whiteArrowLeft.toString() +"px");  //white
                obj.pseudoStyle("after","bottom",whiteArrowBottom.toString() +"px");
                obj.pseudoStyle("after","border-width",sizeWhite.toString() +"px");
            }
            else
            {

                obj.pseudoStyle("after","border-left -color","transparent");
                obj.pseudoStyle("after","border-top-color",obj.style.backgroundColor);
                obj.pseudoStyle("after","border-right-color",obj.style.backgroundColor);
                obj.pseudoStyle("after","border-bottom-color","transparent");

                obj.pseudoStyle("before","right",blackArrowLeft.toString() +"px");  //black
                obj.pseudoStyle("before","bottom",blackArrowBottom.toString() +"px");
                obj.pseudoStyle("before","border-width",sizeBlack.toString() +"px");

                obj.pseudoStyle("after","right",whiteArrowLeft.toString() +"px");  //white
                obj.pseudoStyle("after","bottom",whiteArrowBottom.toString() +"px");
                obj.pseudoStyle("after","border-width",sizeWhite.toString() +"px");

            }



        }
    }

    if (readIni('str',id,'isButton','0') ==  "1")
    {
        if (readIni('str',id,'MemValue','') !=  "")
        {
            if (readIni('str', 'Side' + sidetal, 'MemoryOpenCards', '0') != '1')
            {
                obj.style.backgroundImage = 'url("' + webDirStr + 'data/MemoryBack' + sidetal +'.png")';
                obj.style.backgroundSize = "contain";
                document.getElementById("img" + id).style.display  = "none";
                document.getElementById("lb" + id).style.display  = "none";
                obj.style.borderWidth = "0px";
                obj.style.borderRadius = "10px";
            }
        }

        obj.style.color = '#' + readIni('str', id, 'FontColor' , '000000');
        var myColor = '#' + readIni('str', id, 'Color' , 'F0F0F0');
        obj.style.backgroundColor = myColor;

        obj.style.borderLeftColor = LightenDarkenColor(myColor, 0.2);
        obj.style.borderTopColor = LightenDarkenColor(myColor, 0.2);

        obj.style.borderRightColor = LightenDarkenColor(myColor, -0.20);
        obj.style.borderBottomColor = LightenDarkenColor(myColor, -0.2);
        obj.style.fontSize = (parseInt(readIni('str', id, 'FontSize' , '20' )) * projectScale * 1.3).toString() +"px";

        if (readIni('str',id,'fsBold','0') ==  "1") {obj.style.fontWeight = "bold";}
        if (readIni('str',id,'fsItalic','0') ==  "1") {obj.style.fontStyle = "italic";}
        if ((readIni('str',id,'fsUnderline','0') ==  "1") && (readIni('str',id,'fsStrikeOut','0') ==  "1"))
        {obj.style.textDecoration = "underline line-through";}
        else
        if (readIni('str',id,'fsUnderline','0') ==  "1") {obj.style.textDecoration = "underline";}
        else
        if (readIni('str',id,'fsStrikeOut','0') ==  "1") {obj.style.textDecoration = "line-through";}

        if (readIni('str',id,'SHBorder','1') ==  "0")
        {
            obj.style.borderWidth = "0px";
        }



        obj.style.fontFamily = readIni('str', id, 'FontName' , 'ariel');
        var img = document.getElementById("img" + id);

        var labelHeight = parseInt(readIni('str', id, 'FontSize' , '20' )) * projectScale;

        var margen = parseInt(readIni('str',id,'Margen',"0"));
        margen = margen * projectScale;
        if (margen == 0) {margen = newWidth / 20};

        if (readIni('str',id,'TAlignV','1') ==  "1")
        {
            obj.style.justifyContent  = "center";
            img.style.left = "50%";
            img.style.top = "50%";
            img.style.maxWidth = (newWidth - 2 * margen).toString() + 'px';
            img.style.maxHeight = (newHeight - 2 * margen).toString() + 'px';
        }
        else
        if (readIni('str',id,'TAlignV','1') ==  "0")
        {
            obj.style.justifyContent  = "flex-end";
            img.style.left = "50%";

            img.style.maxWidth = (newWidth - 2 * margen).toString() + 'px';
            img.style.maxHeight = (newHeight - margen - labelHeight).toString() + 'px';
            img.style.top = ((newHeight - labelHeight) / 2).toString() + 'px';
        }
        else
        if (readIni('str',id,'TAlignV','1') ==  "2")
        {
            obj.style.justifyContent  = "flex-start";
            img.style.left = "50%";
            img.style.maxWidth = (newWidth - 2 * margen).toString() + 'px';
            img.style.maxHeight = (newHeight - margen - labelHeight).toString() + 'px';
            img.style.top = (labelHeight + (newHeight - labelHeight) / 2).toString() + 'px';
        }

    }

    if (readIni('str',id,'PDisplay','0') ==  "1") //point display button
    {
        var objLabel = document.getElementById(id + 'label');
        objLabel.style.position = "absolute";
        objLabel.style.fontSize = (parseInt(readIni('str', id, 'FontSize' , '20' )) * projectScale * 1.3).toString() +"px";
        objLabel.style.fontFamily = readIni('str', id, 'FontName' , 'Ariel' );
        var cap = readIni('str', id, 'Caption', '#')
        cap = cap.replace("#", "0");
        cap = cap.replace("~", "");
        objLabel.innerHTML = cap;
        var labelLeft = newLeft + (newWidth - objLabel.clientWidth) / 2;
        objLabel.style.left =  labelLeft.toString() + "px";

        var labelTop = newTop + (newHeight - objLabel.clientHeight) / 2;
        objLabel.style.top =  labelTop.toString() + "px";

        if (isResizing == false)
        {
            if (readIni('int',id,'VisObjekt','1') == "1")
            {objLabel.style.visibility = "visible"}
            else
            {objLabel.style.visibility = "hidden"};
        }

    }

    //end set position

    // start set visibility
    setTimeout(function ()
    {
     	//window.addEventListener("keydown",myKeyboardEvent , true);
        //exitpageProperties();
        //pageLoadCode();

        if (id == "right")
        {
        	if (readIni('int',"Side" + sidetal,'WebShowRight','1') == "1")
            {obj.style.visibility = "visible"}
            else
            {obj.style.visibility = "hidden"};
    	}else if (id == "left")
        {
        	if (readIni('int',"Side" + sidetal,'WebShowLeft','1') == "1")
            {obj.style.visibility = "visible"}
            else
            {obj.style.visibility = "hidden"};
    	}else
    	{
            if (isResizing == false)
            {
                if (readIni('int',id,'VisObjekt','1') == "1")
                {obj.style.visibility = "visible"}
                else
                {obj.style.visibility = "hidden"};

                //if {obj.style.visibility == "visible"}
                if (doBlend(false,true) == true)
                {
                      if (readIni('str', id, 'Function' , '') == 'blend:no'){obj.style.visibility = "visible"};
                      if (readIni('str', id, 'Function' , '') == 'blend:yes'){obj.style.visibility = "hidden"};
                }
                else
                {
                      if (readIni('str', id, 'Function' , '') == 'blend:no'){obj.style.visibility = "hidden"};
                      if (readIni('str', id, 'Function' , '') == 'blend:yes'){obj.style.visibility = "visible"};
                }
            }
    	}
    // end set visibility
    }, 100);
}

    var UID ={_current: 0, getNew: function(){this._current ++; return this._current;}};

    HTMLElement.prototype.pseudoStyle = function(element,prop,value)
    {
    	var _this = this;
    	var _sheetId = "pseudoStyles";
    	var _head = document.head || document.getElementsByTagName('head')[0];
    	var _sheet = document.getElementById(_sheetId) || document.createElement('style');
    	_sheet.id = _sheetId;
    	var className = "pseudoStyle" + UID.getNew();

    	_this.className +=  " "+ className;

    	_sheet.innerHTML += " ." + className + ":" + element + "{" + prop + ":" + value + "}";
    	_head.appendChild(_sheet);
    	return this;
    };


function doShowObjects(id,event)
{
    var str = readIni('str',id,event,'');

    if (str == ''){return}

    showArray = str.split(" ");
    if (showArray.length == 0){return};

    for (var i = 0; i < showArray.length; i++)
    {
        var obj = document.getElementById(showArray[i]);
        if (obj != undefined) {obj.style.visibility = "visible"; };

        var label = document.getElementById(showArray[i] + 'label');
        if (label != undefined) {label.style.visibility = "visible";}
    };
}

function doHideObjects(id,event)
{
    var str = readIni('str',id,event,'');
    if (str == ''){return}
    hideArray = str.split(" ");
    if (hideArray.length == 0){return};

    for (var i = 0; i < hideArray.length; i++)
    {
        var obj = document.getElementById(hideArray[i]);
        if (obj != undefined) {obj.style.visibility = "hidden"; };

        var label = document.getElementById(hideArray[i] + 'label');
        if (label != undefined) {label.style.visibility = "hidden";}
    };
}

function ValidURL(str) {
  var pattern = new RegExp('^(https?:\/\/)?'+ // protocol
    '((([a-z\d]([a-z\d-]*[a-z\d])*)\.)+[a-z]{2,}|'+ // domain name
    '((\d{1,3}\.){3}\d{1,3}))'+ // OR ip (v4) address
    '(\:\d+)?(\/[-a-z\d%_.~+]*)*'+ // port and path
    '(\?[;&a-z\d%_.~+=-]*)?'+ // query string
    '(\#[-a-z\d_]*)?$','i'); // fragment locater
  if(!pattern.test(str)) {
    alert("Please enter a valid URL.");
    return false;
  } else {
    return true;
  }
}

function doExecuteLink(id) {

    var s = readIni('str', id, 'ExeFile', 'xyz');

    if (readIni('str', id, 'ExVideoIV', "0") == "1")
    {
        window.location.assign(webDirStr + id + "_vlink.htm");
        return;
    }
    else
    if (s.split('.').pop().toLowerCase() == "pdf" )
    {
        var path = window.location.pathname;
        var currentPage = path.split("/").pop();
        if (currentPage == "index.html")
        {
            window.open("pages/data/" + s, '_blank')
        }
        else
        {
            window.open("data/" + s, '_blank')
        }
        return;
    }
    else
    if (s.search("shif:") != -1)
    {

        window.location.assign(webDirStr + id + "_fvlink.htm");
        return;
    }
    if (s.search("http://www.youtube.com/embed") != -1)
    {

        window.location.assign(webDirStr + id + "_y2link.htm");
        return;
    }
    else
    if (s.search("YTFavorite") != -1)
    {

        window.location.assign(webDirStr + id + "_y2link.htm");
        return;
    }
    else
    if (s.search("searchYoutube:") != -1)
    {
        window.location.assign(webDirStr + id + "_y2link.htm");
        return;
    }

    if (s.search("http://") != -1)
    {
        window.location.assign(s);
        return;
    }
    else
    if (s.search("https://") != -1)
    {
        window.location.assign(s);
        return;
    }
    else
    if (s.search("www.") != -1)
    {
        window.location.assign(s);
        return;
    }

}

function doChangePage(id,event)
{
    var i;
    var index;
    var goTo = sidetal;
    var relativePath = '';
    if (id == "right") {goTo = "999998"} else
    if (id == "left") {goTo = "999997"} else
    if (id == "home") {goTo = pageArray[0]} else
    {
        goTo = readIni('str',id,event,sidetal);

        //object events
        if (event == 'SkiftTil'){relativePath = readIni('str',id,'MK_2P','')} else
        if (event == 'MusIndSkiftTil' ){relativePath = readIni('str',id,'MusInd_2P','')} else
        if (event == 'MusUdSkiftTil' ){relativePath = readIni('str',id,'MusUd_2P','')} else
        if (event == 'GoToRigthTextPage' ){relativePath = readIni('str',id,'GoToRigthTextPage_2P','')} else
        if (event == 'GoToWrongTextPage' ){relativePath = readIni('str',id,'GoToWrongTextPage_2P','')} else
        //page events
        if (event == 'SideVisSkiftTil' ){relativePath = readIni('str',id,'SideVis_2P','')} else
        if (event == 'OnScorePage' ){relativePath = readIni('str',id,'OnScore_2P','')} else
        if (event == 'GoToMemoryPageMR' ){relativePath = readIni('str',id,'GoToMemoryPageMR_2P','')} else
        if (event == 'GoToMemoryPageMW' ){relativePath = readIni('str',id,'GoToMemoryPageMW_2P','')} else
        if (event == 'GoToMemoryPage' ){relativePath = readIni('str',id,'GoToMemoryPage_2P','')} else
        //project events
        if (event == 'PageVisited_2P' ){relativePath = readIni('str','Project','PageVisited_2P','')} else
        //dragdrop events
        if (event.indexOf("DD") == 0)
        {
            event = event.replace("Sideskift", "2P");
           relativePath = readIni('str',id, event,'');
        } else
        //timeline events
        if (event == 'TimelineInfo')
        {
            relativePath = readIni('str',id, event + '_2P','');
        }
        else
        return;









        if (relativePath !== '')
        {
            window.location.assign(relativePath);
            return;
        }


    }



    for (i = 0; i < pageArray.length; i++)
    {
        if (pageArray[i] ==  sidetal) {index = i}
    }

    if (goTo == 999999)
    {
        window.history.back();
        return;
    }

    if (goTo == 999998)
    {
        if (index < pageArray.length - 1)
        {goTo = pageArray[index + 1]} else {goTo = 'exit.htm'}
    }

    if (goTo == 999997)
    {

     var path = window.location.pathname;
        var currentPage = path.split("/").pop();

        if (currentPage == 'exit.htm')
        {
            index = pageArray.length;
            sidetal == '100000';
        }

        if (index > 0)
        {goTo = pageArray[index - 1]} else {goTo = sidetal}
    }

    if (goTo == 999994)
    {
        var randowPageArray = [];
        for (i = 0; i < pageArray.length; i++)
        {
            if (readIni('str',"Side" + pageArray[i],"InRandomList",'0') == "1")
            {
                if (pageArray[i] !== sidetal )
                {
                   randowPageArray.push(pageArray[i]);
                }
            }
            if (randowPageArray.length > 0)
            {
                randowPageArray = shuffle(randowPageArray);
                goTo = randowPageArray[0];
            }
        }

    }

    if (goTo == "index") {goTo = pageArray[0]};

    if (goTo !== sidetal)
    {
        if (goTo == 'exit.htm')
        {
            if (readIni('str',"Projekt","Replay",'0') == "1")
            {
                if (sidetal == pageArray[0])
                {
                   window.location.assign('index.html');
                }
                else
                {
                   window.location.assign('../index.html');
                }
            }
            else
            {
                if (sidetal == pageArray[0])
                {
                   window.location.assign('pages/exit.htm');
                }
                else
                {
                   window.location.assign('exit.htm');
                }
            }
            return;
        }

        if (sidetal == pageArray[0])
        {
            goTo = 'pages/' + goTo;
        }

        if (goTo == pageArray[0]) {goTo = "../index"};


        window.location.assign(goTo + '.html')
    }
}

function doTerminate(id,event)
{
    if (id == "right"){return};
    if (id == "left"){return};
    if (readIni('str',id,event,'0') == '0'){return}
     var path = window.location.pathname;
     var currentPage = path.split("/").pop();

    if (currentPage == 'index.html')
    {
        window.location.assign('pages/mmwebviewerexit.htm');
    }
    else
    {
        window.location.assign('mmwebviewerexit.htm');
    }

}

function doLoadScript(url, callback){

    var script = document.createElement("script")
    script.type = "text/javascript";

    if (script.readyState){  //IE
        script.onreadystatechange = function(){
            if (script.readyState == "loaded" ||
                    script.readyState == "complete"){
                script.onreadystatechange = null;
                callback();
            }
        };
    } else {  //Others
        script.onload = function(){
            callback();
        };
    }

    script.src = url;
    document.getElementsByTagName("head")[0].appendChild(script);
}

function doSpeak(input)
{
    /*
    if (input == ""){return};
    var speakLoaded = $('script[src="http://code.responsivevoice.org/responsivevoice.js"]').length;
    if (speakLoaded == 0){return};
    try
    {
        responsiveVoice.speak(input,"Danish Female");
    }
    catch(err)
    {
        document.getElementById("demo").innerHTML = err.message;
    }
    */
}

function doExecuteFunctionButton(id)
{
   if (readIni('str', id, 'CRWButton', '') == 'crw:swap')
    {
        crosswordStyle(true);
    };


   if (readIni('str', id, 'KB_Button', '') == 'key:swap')
    {
        capsLock(true,id);
    };

   if (readIni('str', id, 'Function', '') == 'blend:yes')
    {
        if (doBlend(false,true) == false)
        {
            doBlend(true,true);
            pageLoadCode(false);
        }

    };

   if (readIni('str', id, 'Function', '') == 'blend:no')
    {
        if (doBlend(false,true) == true)
        {
            doBlend(true,false);
            pageLoadCode(false);
        }
    };


}

function stopAllAudio()
{
    var myAudios = document.getElementsByTagName('AUDIO');
    i = myAudios.length;

    while (i--)
    {
        myAudios[i].pause();
        myAudios[i].currentTime = 0.0;
        document.body.removeChild(myAudios[i]);
    }
}


function doPlaySound(id,event)
{
    if (id == "right"){return};
    if (id == "left"){return};

    if (readIni('str',id,event,'') == "") {return};

    stopAllAudio();
    var myAudio = document.createElement('audio');
    myAudio.setAttribute("src",webDirStr + "data/" + readIni('str',id,event,''))
    myAudio.setAttribute('display','none');

    document.body.appendChild(myAudio);
    myAudio.play();

    /*
    var sounds = document.getElementsByTagName('audio');
    for(i = 0; i < sounds.length; i++)
    {
        sounds[i].autoplay = true;
        sounds[i].oncanplay = function() {sounds[i].play()}
        sounds[i].play();
    }  */
}

function doStartVideo(id,event)
{
    var videoId = readIni('str', id, event, '');
    if (videoId != '')
    {
        var vid = document.getElementById(videoId);
        vid.play();
    }
}

// DOM 2 Events

function clickElement(element)
{
    var dispatchMouseEvent = function(target, var_args)
    {
        var e = document.createEvent("MouseEvents");
        // If you need clientX, clientY, etc., you can call
        // initMouseEvent instead of initEvent
        e.initEvent.apply(e, Array.prototype.slice.call(arguments, 1));
        target.dispatchEvent(e);
    };
    dispatchMouseEvent(element, 'mouseover', true, true);
    dispatchMouseEvent(element, 'mousedown', true, true);
    dispatchMouseEvent(element, 'click', true, true);
    dispatchMouseEvent(element, 'mouseup', true, true);
}

function eventFire(el, etype)
{
    if (el.fireEvent)
    {
        el.fireEvent('on' + etype);
    } else
    {
        var evObj = document.createEvent('Events');
        evObj.initEvent(etype, true, false);
        el.dispatchEvent(evObj);
    }
}


function pageSoundAutoPageChange()
{
    //*********************** start audio

    var pageAudioEnded = true;
    var autoInterval = parseInt(readIni('str','Lyd','Delay','3000'));

    if (readIni('str',"Side" + sidetal,'SVSound','') !== "")
    {
        var pageAudio = document.createElement('audio');
        pageAudio.setAttribute("src",webDirStr + "data/" + readIni('str',"Side" + sidetal,'SVSound',''))
        pageAudio.setAttribute('display','none');
        pageAudio.onpause = function(){pageAudioEnded = true};
        pageAudio.onended = function(){pageAudioEnded = true};

        document.body.appendChild(pageAudio);

        pageAudioEnded = false;
        autoInterval = 500;

        var sounds = document.getElementsByTagName('audio');
        for(i = 0; i < sounds.length; i++)
        {   sounds[i].autoplay = true;
            sounds[i].oncanplay = function() {sounds[i].play()}
            sounds[i].play();
        }

    }

    //*********************** end audio


    //*********************** start autoshift
    if (readIni('str','Projekt','Autoskift','0') == "1")
    {
        setInterval(function()
        {
            if (pageAudioEnded) {doChangePage('right','')}
        }, autoInterval);
    }
    else

    {
        if (readIni('str',"Side" + sidetal,'SVSound','') !== "")
        {
            setInterval(function()
            {
                if (pageAudioEnded) {doChangePage('Side' + sidetal,'SideVisSkiftTil'); }
            }, 500);
        }
        else
        {
            doChangePage('Side' + sidetal,'SideVisSkiftTil');
        }
    }

    //*********************** end autoshift
}

function blendObjects()
{
    var index;

    var tempBlendArray = [];
    var str = readIni('str',"Side" + sidetal,'BLObjects','');
    if (str == '') {return};

    tempBlendArray = str.split(" ");

    {
        var subArray = [];
        var subIndex;
        var blendSubArray = [];
        for (index = 0; index <  objArray.length; index++)
        {
            if (tempBlendArray.indexOf(objArray[index]) != -1)
            {
                subArray.push(objArray[index]);
                blendSubArray.push(objArray[index]);
            }
        }
        if (doBlend(false,true) == true)
        {
            blendSubArray = shuffle(blendSubArray);
        }


        for (index = 0; index <  blendObjArray.length; index++)
        {
           subIndex = subArray.indexOf(blendObjArray[index]);
           if (subIndex != -1)
           {
                blendObjArray[index] = blendSubArray[subIndex];
           }
        }
    }
}


function blendMemoryCards()
{
    var index;

    if (readIni('str', 'Side'+ sidetal, 'MemoryPage', '0') != '1') {return};
    if (readIni('str','Side'+ sidetal,'BlendMemoryCards',1) == 0) {return};

    if (readIni('str','Side'+ sidetal,'BlendMemoryCards',1) == 1)
    {
        var subArray = [];
        var subIndex;
        var blendSubArray = [];
        for (index = 0; index <  objArray.length; index++)
        {
            if (readIni('str',objArray[index],'MemValue',"0") != "0")
            {
                subArray.push(objArray[index]);
                blendSubArray.push(objArray[index]);
            }
        }

        blendSubArray = shuffle(blendSubArray);

        for (index = 0; index <  blendObjArray.length; index++)
        {
           subIndex = subArray.indexOf(blendObjArray[index]);
           if (subIndex != -1)
           {
                blendObjArray[index] = blendSubArray[subIndex];
           }
        }
    }

    if (readIni('str','Side'+ sidetal,'BlendMemoryCards',1) == 2)
    {
        var subArray = [];
        var subIndex;
        var blendSubArray = [];
        //mix A-buttons start
        for (index = 0; index <  objArray.length; index++)
        {
            if (readIni('str',objArray[index],'MemAorB',"") == "A")
            {
                subArray.push(objArray[index]);
                blendSubArray.push(objArray[index]);
            }
        }

        blendSubArray = shuffle(blendSubArray);

        for (index = 0; index <  blendObjArray.length; index++)
        {
           subIndex = subArray.indexOf(blendObjArray[index]);
           if (subIndex != -1)
           {
                blendObjArray[index] = blendSubArray[subIndex];
           }
        }

        subArray.length = 0;
        blendSubArray.length = 0;

        //mix B-buttons start
        for (index = 0; index <  objArray.length; index++)
        {
            if (readIni('str',objArray[index],'MemAorB',"") == "B")
            {
                subArray.push(objArray[index]);
                blendSubArray.push(objArray[index]);
            }
        }

        blendSubArray = shuffle(blendSubArray);

        for (index = 0; index <  blendObjArray.length; index++)
        {
           subIndex = subArray.indexOf(blendObjArray[index]);
           if (subIndex != -1)
           {
                blendObjArray[index] = blendSubArray[subIndex];
           }
        }
    }

    if (readIni('str','Side'+ sidetal,'BlendMemoryCards',1) == 3)
    {
        var subArray = [];
        var subIndex;
        var blendSubArray = [];
        //mix A-buttons start
        for (index = 0; index <  objArray.length; index++)
        {
            if (readIni('str',objArray[index],'MemAorB',"") == "A")
            {
                subArray.push(objArray[index]);
                blendSubArray.push(objArray[index]);
            }
        }

        blendSubArray = shuffle(blendSubArray);

        for (index = 0; index <  blendObjArray.length; index++)
        {
           subIndex = subArray.indexOf(blendObjArray[index]);
           if (subIndex != -1)
           {
                blendObjArray[index] = blendSubArray[subIndex];
           }
        }
    }

    if (readIni('str','Side'+ sidetal,'BlendMemoryCards',1) == 4)
    {
        var subArray = [];
        var subIndex;
        var blendSubArray = [];
        //mix B-buttons start
        for (index = 0; index <  objArray.length; index++)
        {
            if (readIni('str',objArray[index],'MemAorB',"") == "B")
            {
                subArray.push(objArray[index]);
                blendSubArray.push(objArray[index]);
            }
        }

        blendSubArray = shuffle(blendSubArray);

        for (index = 0; index <  blendObjArray.length; index++)
        {
           subIndex = subArray.indexOf(blendObjArray[index]);
           if (subIndex != -1)
           {
                blendObjArray[index] = blendSubArray[subIndex];
           }
        }
    }
}
/*
function touchHandler(event)
{
 var touches = event.changedTouches,
        first = touches[0],
        type = "";

         switch(event.type)
    {
        case "touchstart": type = "mousedown"; break;
        case "touchmove":  type="mousemove"; break;
        case "touchend":   type="mouseup"; break;
        default: return;
    }

    var simulatedEvent = document.createEvent("MouseEvent");
    simulatedEvent.initMouseEvent(type, true, true, window, 1,
                              first.screenX, first.screenY,
                              first.clientX, first.clientY, false,
                              false, false, false, 0, null);
    first.target.dispatchEvent(simulatedEvent);
    event.preventDefault();
}  */

function oneFolderUp(url)
{
    if (url.slice(-1) == '/') {url = url.substr(0, url.length - 1)};

    var tempArray = url.split('/');
    tempArray.pop();

    return tempArray.join('/');
}

function getProjectRootFolderName()
{
    var path = document.location.pathname;
    var tempArray = path.split('/');
    if (tempArray[tempArray.length - 1] !== 'index.html')
    {
        tempArray.pop();
    }
    tempArray.pop();
    return tempArray[tempArray.length - 1];
}

function getProjectRootDir()
{
    var url = window.location.pathname;
    var filename = url.substring(url.lastIndexOf('/') + 1);
    var path = '';
    if (filename == "index.html")
    {
        path = "../"
    }
    else
    {
        path = "../../"
    }
    return path;



    var path = document.location.pathname;
    if (path.slice(-1) == '/') {path = path.substr(0, url.length - 1)};
    var tempArray = path.split('/');

    //alert(tempArray[tempArray.length - 1]);
    if (tempArray[tempArray.length - 1] !== 'index.html')
    {
        tempArray.pop();
    }
    tempArray.pop();
    var str = tempArray.join('/');

    str = str.substr(1);
    return str;
}

function loadJS(file) {
    // DOM: Create the script element
    var jsElm = document.createElement("script");
    // set the type attribute
    jsElm.type = "application/javascript";
    // make the script element load file
    jsElm.src = file;
    // finally insert the element to the body element in order to load the script
    document.body.appendChild(jsElm);
}


function doExitToMenu()
{
    window.location.assign('mmwebviewerexit.htm');
}

function getWebpageName()
{
    var url = window.location.pathname;
    var filename = url.substring(url.lastIndexOf('/') + 1);
    return filename;
}

function pageLoadCode(onLoad)
{

            var str = readIni('str','Project','Pages','');
            pageArray = str.split(" ");
            if (onLoad == true)
            {
                document.addEventListener("contextmenu", function(e){e.preventDefault();}, false);
                var webpageName = getWebpageName();

                if (webpageName == "index.html") {sidetal = pageArray[0]} else {sidetal = webpageName.replace(".html", "")}

                if (sidetal == pageArray[0]) {webDirStr = 'pages/'};

                setProjectScale();
                scorePoint("",true);

                document.body.style.backgroundColor = "#" + readIni('str',"Side" + sidetal,'ForeColor','0');
            }

            var str = readIni('str',"Side" + sidetal,'Objstr','');
            objArray.length = 0;
            objArray = str.split(" ");
            blendObjArray = str.split(" ");
            blendObjects();

            if (onLoad == true)
            {
                blendMemoryCards();
                SetupDragDrop();
            };



            for (var index = 0; index <  objArray.length; index++)
            {
                objProperties(objArray[index],false);
                if (onLoad == true)
                {
                    if (readIni('str',objArray[index],'SpeechSV','0') == "1") {doSpeak(readIni('str',objArray[index],'RightText',''))}
                }
            }

            if (onLoad == true)
            {
                for (var index = 0; index <  objArray.length; index++)
                {
                    hotspotOnTop(objArray[index]);
                }

                objProperties('sldcontainer',false);
                if (readIni('str',"Side" + sidetal,'WebShowRight','1') == "1") {objProperties('right',false)};
                if (readIni('str',"Side" + sidetal,'WebShowLeft','1') == "1") {objProperties('left',false)};
                objProperties('speaker',false);
                if (canAutoplay == true)
                {

                    setTimeout(function()
                    {
                        pageSoundAutoPageChange();
                        doExecuteTimeline(readIni('str',"Side" + sidetal,'StartTimelineSideVis',''));
                    }, 300);

                }
                else
                {
                    if (soundOrVideoInTimeline(readIni('str',"Side" + sidetal,'StartTimelineSideVis','')) == false)
                    {
                        setTimeout(function()
                        {
                            doExecuteTimeline(readIni('str',"Side" + sidetal,'StartTimelineSideVis',''));
                        }, 300);
                    }
                    if (readIni('str',"Side" + sidetal,'SVSound','') == '')
                    {
                        doChangePage('Side' + sidetal,'SideVisSkiftTil');
                    }

                }

                startScanning(false);
                loadSLineD("load");
                user_onload();

            }


            //document.addEventListener("touchstart", myOnclick(e), true);
            //document.addEventListener("touchmove", touchHandler, true);
            //document.addEventListener("touchend", touchHandler, true);
            //document.addEventListener("touchcancel", touchHandler, true);


}

function checkAutoplayByCode()
{
    var checkaudio = new Audio("");
    checkaudio.autoplay = true;
    checkaudio.oncanplay = function() {checkaudio.play()}
    checkaudio.onended = function()
    {
        canAutoplay = true;
    }
    var path = window.location.pathname;
    var currentPage = path.split("/").pop();
    if (currentPage == "index.html")
    {checkaudio.src = "pages/data/check.mp3";}
    else
    {checkaudio.src = "data/check.mp3";}

    checkaudio.play();
}

function clickSpeaker()
{
    $("#speaker").remove();
    pageSoundAutoPageChange();
    if (soundOrVideoInTimeline(readIni('str',"Side" + sidetal,'StartTimelineSideVis','')) == true)
    {
        doExecuteTimeline(readIni('str',"Side" + sidetal,'StartTimelineSideVis',''));
    }
}



function pageOnLoad()
{

    checkAutoplayByCode();
    if ( (getOperatingSystem() == "iOS") || (getOperatingSystem() == "Android"))
    {
        var count = 0;
        var loadiOSTimer = setInterval(function ()
        {
            count = count + 1;

            if (canAutoplay == true)
            {
                clearTimeout(loadiOSTimer);
                $("#speaker").remove();
                window.addEventListener("keydown",myKeyboardEvent , true);
                exitpageProperties();
                pageLoadCode(true);
            }
            else
            if (count > 10)
            {
                clearTimeout(loadiOSTimer);
                if ( (soundOrVideoInTimeline(readIni('str',"Side" + sidetal,'StartTimelineSideVis','')) == true) || (readIni('str',"Side" + sidetal,'SVSound','') !== "") )
                {
                    document.getElementById("speaker").style.visibility = "visible";
                }
                window.addEventListener("keydown",myKeyboardEvent , true);
                exitpageProperties();
                pageLoadCode(true);
            }
        }, 200);

    }
    else //not iOS Andoroid
    {
        canAutoplay = true;
        $("#speaker").remove();
        setTimeout(function ()
        {
            window.addEventListener("keydown",myKeyboardEvent , true);
            exitpageProperties();
            pageLoadCode(true);
        }, 100);

    }

        //window.addEventListener("orientationchange", function() {
        //location.reload();
        //}, false);



}
//end ***************** PageOnload

var startScanning = (function noCall_startScanning() {
    var scanInterval;
    return function (stop)
    {
        if (stop == true)
        {
            clearInterval(scanInterval);
        }
        else
        {
            scanObject(true);
            window.focus();
            scanInterval = setInterval(function ()
            {
                scanObject(true);
                window.focus();
            }, 6400);
        }
    }
})();


function myKeyboardEvent(event)
{
    var x = event.which;
    //if (getOperatingSystem() == "iOS"){alert(x)};
    //
    if ((event.ctrlKey) && (x == "36")  )
    {
        doChangePage('home','');
    }
    if ((x == "34")|| (x == "39"))
    {
        if  ((document.getElementById('right') !== null) || (readIni('str',"Siden",'IgnoreHiddenArrows','0') == "1"))
        {
            doChangePage('right','');
        }
    }

    if ((x == "33")|| (x == "37"))
    {
        if  ((document.getElementById('left') !== null) || (readIni('str',"Siden",'IgnoreHiddenArrows','0') == "1"))
        {
            doChangePage('left','');
        }
        else
        if (getWebpageName() == "exit.htm")
        {
            doChangePage('left','');
        }

    }

    if (x == "40")
    {
       scanObject();
    }

    document.focus();
}




function onResize()
{
    setProjectScale();
    var index;
    for (index = 0; index < objArray.length; index++) {objProperties(objArray[index],true)}
    objProperties('right',false);
    objProperties('left',false);
    objProperties('sldcontainer',false);
    if (readIni('str',"Side" + sidetal,'SVSound','') !== "") {objProperties('speaker',false)};
}

function myOnKeyUp(id)
{
    checkForRightText(id,document.getElementById(id).value);
}

function myOnclick(id)
{
    //var len = $('script[src="data/mmscript.js"]').length;
    //alert(len + "int");
    //responsiveVoice.speak("Hej verden","Danish Female");
/**
    responsiveVoice.speak("Hej verden","Danish Female");
   if ('speechSynthesis' in window)
    {
    //var msg = new SpeechSynthesisUtterance('Hej med dig');
    //window.speechSynthesis.speak(msg);
    }
    **/

    if (readIni('str',id,'ClipTalkShowHide','0') == "1") {doSpeak(readIni('str',id,'RightText',''))}

    if (readIni('str',"Side" + sidetal,'pagename','0') == "xmasmenu")  //julekalender
    {
        var d = new Date();

        if (parseInt(d.getMonth()) == 11) //11 = december
        {
            var cap = readIni('str',id,'Caption','');
            cap = cap.replace("~", "");
            if (isNaN(cap) == false) //its a number
            {
                if (parseInt(cap) <= d.getDate()) {doChangePage(id,'SkiftTil');}
            }
        }
    }
    else
    {
        doChangePage(id,'SkiftTil');
    }

    if (id == "right"){return};
    if (id == "left"){return};

    doShowObjects(id,'MusKlikVis');
    doHideObjects(id,'MusKlikSkjul');

    doExecuteLink(id,'ExeFile');
    doPlaySound(id,'MKSound');
    doTerminate(id,'AfslutMusKlik');
    playMemory(id);
    playCrossWord(id);
    doExecuteFunctionButton(id);
    doSendText(id);
    doStartVideo(id,'StartVideoMusKlik');

    doExecuteTimeline(readIni('str',id,'StartTimelineMusKlik',''));

    scorePoint(id + "_MK",false);
    user_onclick(id);
}


function myMouseEnter(id)
{

    if (readIni('str',id,'isButton','0') ==  "1")
    {
        var myColor = '#' + readIni('str', id, 'MouseOverColor' , 'F0F0F0');
        var obj = document.getElementById(id);
        obj.style.backgroundColor = myColor;

        obj.style.borderLeftColor = LightenDarkenColor(myColor, 0.2);
        obj.style.borderTopColor = LightenDarkenColor(myColor, 0.2);
        obj.style.borderRightColor = LightenDarkenColor(myColor, -0.2);
        obj.style.borderBottomColor = LightenDarkenColor(myColor, -0.2);
    }

    if (id == "right"){return};
    if (id == "left"){return};
    doShowObjects(id,'MusIndVis');
    doHideObjects(id,'MusIndSkjul');
    doChangePage(id,'MusIndSkiftTil');
    doPlaySound(id,'MISound');
    doTerminate(id,'AfslutMusInd');
    scorePoint(id + "_MI",false);
    doStartVideo(id,'StartVideoMusInd');
    doExecuteTimeline(readIni('str',id,'StartTimelineMusInd',''));
    user_onenter(id);
}

function myMouseLeave(id)
{
    if (readIni('str',id,'isButton','0') ==  "1")
    {
        var myColor = '#' + readIni('str', id, 'Color' , 'F0F0F0');
        var obj = document.getElementById(id);
        obj.style.backgroundColor = myColor;

        obj.style.borderLeftColor = LightenDarkenColor(myColor, 0.2);
        obj.style.borderTopColor = LightenDarkenColor(myColor, 0.2);
        obj.style.borderRightColor = LightenDarkenColor(myColor, -0.2);
        obj.style.borderBottomColor = LightenDarkenColor(myColor, -0.2);
    }

    if (id == "right"){return};
    if (id == "left"){return};
    doShowObjects(id,'MusUdVis');
    doHideObjects(id,'MusUdSkjul');
    doChangePage(id,'MusUdSkiftTil');
    doPlaySound(id,'MUSound');
    doTerminate(id,'AfslutMusUd');
    scorePoint(id + "_MU",false);
    doStartVideo(id,'StartVideoMusUd');
    doExecuteTimeline(readIni('str',id,'StartTimelineMusUd',''));
    user_onleave(id);
}

var defaultFunction = (function noCall_defaultFunction() {
    var myVar = 0;
    return function (myParameter)
    {


    }
})();


var scanObject = (function noCall_scanObject() {

    var scanIndex = 0;
    var count = 1;
    var obj;


    return function (move)
    {
        var scanObjArray = [];
        var str = readIni('str',"Side" + sidetal,'SkanObjstr','');
        if (str == '') {return};
        scanObjArray = str.split(" ");
        for (index = 0; index < scanObjArray.length; index++)
        {
            if (scanObjArray[index] == "Frem") {scanObjArray[index] = 'right'};
            if (scanObjArray[index] == "Tilbage") {scanObjArray[index] = 'left'};

        }

        if (scanObjArray.length == 0) {return};

        if (move == true)
        {
            if (scanObjArray.length > 1)
            {
                if (scanIndex == 0) {document.getElementById(scanObjArray[scanObjArray.length - 1]).style.boxShadow = ""}
                else {document.getElementById(scanObjArray[scanIndex - 1]).style.boxShadow = ""}
            }

            obj = document.getElementById(scanObjArray[scanIndex]);
            obj.style.boxShadow = "0px 0px 1px 15px red";

            count = 1;
            var blinkInterval=setInterval(
            function()
            {
                if ((count == 1) || (count == 3) || (count == 5) || (count == 7))
                {
                    obj.style.boxShadow = "";
                }
                else
                {
                    obj.style.boxShadow = "0px 0px 1px 15px red";
                }
                count += 1;
                if(count > 7)
                {
                    clearInterval(blinkInterval);
                };


            },800);

            scanIndex += 1;
            if (scanIndex > scanObjArray.length - 1) {scanIndex = 0};
        }
        else
        {
            myOnclick(obj.id);
        }

    }
})();


function dropGlow(id)
{
    var obj = document.getElementById(id);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 2px yellow";}, 30);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 3px yellow";}, 60);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 4px yellow";}, 90);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 5px yellow";}, 120);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 6px yellow";}, 150);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 5px yellow";}, 180);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 4px yellow";}, 210);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 5px yellow";}, 240);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 6px yellow";}, 270);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 5px yellow";}, 300);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 4px yellow";}, 330);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 3px yellow";}, 360);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 2px yellow";}, 390);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 1px yellow";}, 420);
    setTimeout(function () {obj.style.boxShadow = "0px 0px 30px 0px yellow";}, 450);
    setTimeout(function () {obj.style.boxShadow = "";}, 480);
}

function setCookie(cname, cvalue, exdays)
{
    var d = new Date();
    d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
    var expires = "expires="+d.toUTCString();
    document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}

function getCookie(cname)
{
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
}